<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <CommonHeader 
      title="All Executions"
      description="Most-recent benchmark executions. Benchmarks can be executed one off, or ran regularly through schedules. This list contains your own execution and those ran by others, where they shared results with you."
      >
      <v-btn
        @click="init()"
        small
      >
        Refresh
        <v-icon right dark small>mdi-refresh</v-icon>
      </v-btn>
      <v-btn small :disabled="!enabledActions.create" @click="$emit('newExecution', {name:'_hidden_schedule', id:null, grants:{owner:'me'}, tags:['hidden'], active:true, interval:{'weeks':500}})" >New Execution</v-btn>
    </CommonHeader>
        
    <Filterbox
      :filteredSize="filteredExecutions.length"
      :itemsName="['execution', 'executions']"
      v-on:changed="filterkey=$event.key"
      :loading="loading"
    />    
    
    <ExecutionBucket
      :allItems="executionBuckets.lastquarter"
      :filteredItems="lqFilteredExecs"
      bucketName="in the last 15 minutes"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.lasthour"
      :filteredItems="lhFilteredExecs"
      bucketName="in the last hour"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.lastsixhours"
      :filteredItems="lshFilteredExecs"
      bucketName="in the last 6 hours"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.today"
      :filteredItems="todayFilteredExecs"
      bucketName="earlier today"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.lastsevendays"
      :filteredItems="lsdFilteredExecs"
      bucketName="in the last 7 days"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.lastmonth"
      :filteredItems="lmFilteredExecs"
      bucketName="in the last month"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.thisyear"
      :filteredItems="tyFilteredExecs"
      bucketName="this year"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.lastyear"
      :filteredItems="lyFilteredExecs"
      bucketName="last year"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

    <ExecutionBucket
      :allItems="executionBuckets.earlier"
      :filteredItems="eaFilteredExecs"
      bucketName="earlier"
      :loading="loading"
      @selected="$emit('viewExecution', $event)"
    />

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import Filterbox from '../common/Filterbox.vue';
import ExecutionBucket from './ExecutionBucket.vue';

export default {

  name: 'ExecutionsList',

 components: {
    CommonHeader,
    ExecutionBucket,
    Filterbox
  },
  
  data: () => ({
    executions: [],

    executionBuckets: {
      "lastquarter":[],
      "lasthour":[],
      "lastsixhours":[],
      "today":[],
      "lastsevendays":[],
      "lastmonth":[],
      "thisyear":[],
      "lastyear":[],
      "earlier":[]
    },
    
    loading: false,

    enabledActions: {
      create:false
    },
    
    filterkey: ""
  }),

  mounted () {
    this.init();
    this.$emit("title", "Executions");
  },
    
  methods: {
    init: function() {
      this.executions = [];
      for(var k in this.executionBuckets) {
        this.executionBuckets[k] = [];
      }
    
      this.$store.commit('fbkon')
      this.loading=true;
      this.$http
        .get(this.$REST_BASE_URL + '/executions')
        .then(response => {
          this.executions = response.data;
          this.buildSearchText();
          this.buildBuckets();
          this.loading=false;
        })
        .finally(() => {
          this.$store.commit('fbkoff')
        });
      // update actions
      this.$http
            .get(this.$REST_BASE_URL + "/executions/user_actions")
        .then(response => {
          this.enabledActions.create = response.data.create=="True";
        })
    },
    
    buildSearchText: function() {
      for(var i in this.executions) {
        var execution = this.executions[i];
        if(execution._searchText)
          continue;
        var text = "";
        for(var k in execution) {
          if(k=="provider") {
            for(var pk in execution[k]) {
              text += " " + execution[k][pk];
            }
          }
          else if(k=="schedule") {
            for(var sk in execution[k]) {
              text += " " + execution[k][sk];
            }
          } else {
            // ignore status
            if(k=="status")
              continue;
            // consider deep status, instead
            if(k=="runs_status")
              text+=this.getStatus(execution);
            else
              text += " " + execution[k];
          }
        }
        if(execution.status=="RUNNING" || execution.status=="MISSED")
          text+=" "+execution.status;
        if(execution["one-time"])
          text+=" onetime one time one-time ondemand on demand on-demand";
        
        execution._searchText = text;
        
      }
    },
  
    buildBuckets: function() {
      // compute now
      var now = new Date();
      var nowsecs = now.getTime()/1000;
      var todaysecs = new Date(now.getFullYear(), now.getMonth(), now.getDate()).getTime()/1000;
      
      for(var i in this.executions) {
        var execution = this.executions[i];
        // fix the start time
        if(execution.starttime)
          execution.starttime = execution.starttime.replace(" ", "T")+"Z";
        if(execution.endtime)
          execution.endtime = execution.endtime.replace(" ", "T")+"Z";
        // compute diff
        var execTime = Date.parse(execution.starttime)/1000;
        var diff = nowsecs - execTime;
        
        // place it in the correct bucket

        // last 15 minutes
        if(diff < 15*60)
          this.executionBuckets["lastquarter"].push(execution);
        
        // last hour
        else if(diff < 1*60*60)
          this.executionBuckets["lasthour"].push(execution);
          
        // last six hours
        else if(diff < 6*60*60)
          this.executionBuckets["lastsixhours"].push(execution);
          
        // today = midnight to now
        else if(execTime > todaysecs)
          this.executionBuckets["today"].push(execution);

        // last seven days
        else if(diff < 7*24*60*60)
          this.executionBuckets["lastsevendays"].push(execution);
          
        // last ~30 days
        else if(diff < 30*24*60*60)
          this.executionBuckets["lastmonth"].push(execution);
          
        // this year
        else if(new Date(Date.parse(execution.starttime)).getYear() == now.getYear())
          this.executionBuckets["thisyear"].push(execution);
        
        // last year
        else if(new Date(Date.parse(execution.starttime)).getYear() == now.getYear()-1)
          this.executionBuckets["thisyear"].push(execution);
        
        // earlier
        else {
          this.executionBuckets["earlier"].push(execution);
        }
      }
    },
    
    getStatus: function(execution) {
      var subko = 0;
      if(execution && execution.runs_status && execution.runs_status.error)
        subko = execution.runs_status.error.length;
      if(execution.status=="RUNNING" && subko>0)
        return "RUNNING";
      if(execution.status=="RUNNING" && subko==0)
        return "RUNNING";
      if(execution.status=="ERROR")
        return "ERROR";
      if(execution.status=="OK" && subko>0)
        return "ERROR";
      if(execution.status=="OK" && subko==0)
        return "OK";
      return execution.status;
    },
    
    filterfunction: function(execution) {
      if(!this.filterkey)
        return true;
      return execution._searchText.toLowerCase().includes(this.filterkey.toLowerCase());
    }
    
  },
  
  computed: {
    lqFilteredExecs: function() {
      return this.executionBuckets.lastquarter.filter(this.filterfunction);
    },
    lhFilteredExecs: function() {
      return this.executionBuckets.lasthour.filter(this.filterfunction);
    },
    lshFilteredExecs: function() {
      return this.executionBuckets.lastsixhours.filter(this.filterfunction);
    },
    todayFilteredExecs: function() {
      return this.executionBuckets.today.filter(this.filterfunction);
    },
    lsdFilteredExecs: function() {
      return this.executionBuckets.lastsevendays.filter(this.filterfunction);
    },
    lmFilteredExecs: function() {
      return this.executionBuckets.lastmonth.filter(this.filterfunction);
    },
    tyFilteredExecs: function() {
      return this.executionBuckets.thisyear.filter(this.filterfunction);
    },
    lyFilteredExecs: function() {
      return this.executionBuckets.lastyear.filter(this.filterfunction);
    },
    eaFilteredExecs: function() {
      return this.executionBuckets.earlier.filter(this.filterfunction);
    },
    filteredExecutions: function() {
      return this.executions.filter(this.filterfunction);
    }
  }
    
  
};

</script>

<style>
</style>


